use std::sync::{Arc, Mutex};

use crate::database::Client as DatabaseClient;
use serenity::{
    async_trait,
    model::gateway::Ready,
    model::prelude::{interaction::Interaction, ResumedEvent},
    prelude::{Context, EventHandler},
};

const MAX_ARGS_NUMBER: u32 = 25;

pub struct Handler {
    pub database: Arc<Mutex<DatabaseClient>>,
}

#[async_trait]
impl EventHandler for Handler {
    async fn ready(&self, ctx: Context, ready: Ready) {
        println!("Successfully connected as {}", ready.user.name);

        // TODO: Register commands
    }

    async fn resume(&self, _: Context, _: ResumedEvent) {
        println!("Successfully reconnected.")
    }

    async fn interaction_create(&self, ctx: Context, interaction: Interaction) {
        if let Interaction::ApplicationCommand(command) = interaction {
            println!("Received command {}", command.data.name);
        }
    }
}
